05Robot 3.0

- Main Page
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Slots | Signals | Public Member Functions | Public Attributes | Properties | List of all members
CameraObject Class Reference
Computer Vision Module

Wrapper object containing single camera, managing its processing and control pipelines, and properties. More...

`#include <CameraObject.h>`

Inheritance diagram for CameraObject:

## Public Types

## Public Slots
void | cStart ()
| Starts camera pipeline, sets isRunning to true. More...
void | cSync ()
| Sends software trigger to camera. More...
void | cGrab ()
| Copies image from internal buffer to requested buffers. More...
void | cStop ()
| Stops camera pipeline, sets isRunning to true. More...
void | requestImage (void *, void *)
void | requestPoints2 (void *, void *)

## Signals
void | frameOut (cv::Mat *image, int width, int height)
| Emitted at finish of each frame capture. More...
void | writeInfo (QString info)
| Data logger. More...

## Public Member Functions
void | SetcalibrationPath (QString _arg_calibrationPath)
| Sets calibrationPath property value. More...
QString | calibrationPath () const
| Gets calibrationPath property value. More...
void | SetdisplayData (DisplayData _arg_displayData)
| Sets displayData property value. More...
DisplayData | displayData () const
| Gets displayData property value. More...
Q_ENUMS(DisplayData) public void | setCalibrationFileName (const QString &calibrationFileName)
| Gets calibration file path. More...
virtual void | writeXml (QXmlStreamWriter &xml)
| Writes XML entries to file. Can be overloaded to save additional data, apart from object properties. More...
virtual void | readXml (QXmlStreamReader &xml)
| Called by findInXML. Reads XML entries. Has to be overloaded if additional data was written to file in object entry. More...
| CameraObject (Camera *c, int camType, int camId, QSemaphore *ss)
| ~CameraObject ()
Public Member Functions inherited from cXmlIO
| cXmlIO (int _xmlID=0, QObject *parent=nullptr)
virtual QString | sXmlKey ()
| Generates key of XML entry (as name of the serialised class is) More...
virtual void | findInXML (QString &fileName, bool compareXmlID=true)
| serches th file for XML key corr to class name and fill class properties according to entries found More...
virtual void | writeCsvData (QXmlStreamWriter &stream, QString key, const QVector< QVector< double > > &s)
virtual void | writeCsvVector (QXmlStreamWriter &stream, QString key, const QVector< double > &s)
virtual void | readCsvData (QXmlStreamReader &stream, QVector< QVector< double > > &s)
virtual void | readCsvVector (QXmlStreamReader &stream, QVector< double > &s)
virtual void | write64BaseData (QXmlStreamWriter &stream, QString key, const QVector< QVector< double > > &s)
virtual void | read64BaseData (QXmlStreamReader &stream, QVector< QVector< double > > &s)
template<typename T >
void | writeData (QXmlStreamWriter &stream, QString key, const T &data)
template<typename T >
void | readData (QXmlStreamReader &stream, T &data)
int | getXmlID () const
void | setXmlID (int value)

## Public Attributes
cv::Mat | cameraMatrix
| Camera matrix. More...
cv::Mat | distCoeffs
| Distortion coefficients. More...
QString | cameraName
| Camera name. More...
QSemaphore * | syncSem
Camera * | cam
| Pointer to corresponding Camera. More...
int | cameraType
| Corresponding camera type. More...
int | cameraID
| Corresponding camera ID. More...
bool | isRunning
| Camera running flag. More...

## Properties
QString | calibrationPath
| Camera calibration file path. More...
QString | CalibrationFileName
DisplayData | displayData
| Display data type. More...
Properties inherited from cXmlIO
int | xmlID
| Defines uniqe identifier for object in XML file. More...

## Additional Inherited Members
Static Public Member Functions inherited from cXmlIO
static void | metaCopy (QObject *dest, QObject *src)
Protected Member Functions inherited from cXmlIO
void | metaDataXmlReader (QXmlStreamReader &stream, QObject &obj, bool isUser=true)
void | metaDataXmlWriter (QXmlStreamWriter &stream, const QObject &obj, bool isUser=true)

## Detailed Description

Wrapper object containing single camera, managing its processing and control pipelines, and properties.

## Member Enumeration Documentation

enum DisplayData

Display data type enum.

Enumerator
DisplayRawImage | Raw image
DisplayThreshold | Thresholded image
DisplayPoints | Points
DisplayNoImage | No display

## Constructor & Destructor Documentation

CameraObject | ( | Camera * | c,
|  | int | camType,
|  | int | camId,
|  | QSemaphore * | ss
| ) |  |

~CameraObject | ( |  | ) |
| inline

## Member Function Documentation

QString calibrationPath | ( |  | ) | const

Gets calibrationPath property value.

void cGrab | ( |  | ) |
| slot

Copies image from internal buffer to requested buffers.

void cStart | ( |  | ) |
| slot

Starts camera pipeline, sets isRunning to true.

void cStop | ( |  | ) |
| slot

Stops camera pipeline, sets isRunning to true.

void cSync | ( |  | ) |
| slot

Sends software trigger to camera.

DisplayData displayData | ( |  | ) | const

Gets displayData property value.

void frameOut | ( | cv::Mat * | image,
|  | int | width,
|  | int | height
| ) |  |
| signal

Emitted at finish of each frame capture.

Parameters

  image | Pointer to image data
  width | Image width
  height | Image height

virtual void readXml | ( | QXmlStreamReader & | xml | ) |
| virtual

Called by findInXML. Reads XML entries. Has to be overloaded if additional data was written to file in object entry.

Parameters

  xml | reference to stream corresponding to object entry in XML

Reimplemented from cXmlIO.

void requestImage | ( | void * | ,
|  | void * |
| ) |  |
| slot

void requestPoints2 | ( | void * | ,
|  | void * |
| ) |  |
| slot

Q_ENUMS (DisplayData) public void setCalibrationFileName | ( | const QString & | calibrationFileName | ) |
| inline

Gets calibration file path.

Reads calibration file Sets calibration file path

void SetcalibrationPath | ( | QString | _arg_calibrationPath | ) |

Sets calibrationPath property value.

void SetdisplayData | ( | DisplayData | _arg_displayData | ) |

Sets displayData property value.

void writeInfo | ( | QString | info | ) |
| signal

Data logger.

Parameters

  info | text to log

virtual void writeXml | ( | QXmlStreamWriter & | xml | ) |
| virtual

Writes XML entries to file. Can be overloaded to save additional data, apart from object properties.

Parameters

  xml | reference to XML file stream

Reimplemented from cXmlIO.

## Member Data Documentation

Camera* cam

Pointer to corresponding Camera.

int cameraID

Corresponding camera ID.

cv::Mat cameraMatrix

Camera matrix.

QString cameraName

Camera name.

int cameraType

Corresponding camera type.

cv::Mat distCoeffs

Distortion coefficients.

bool isRunning

Camera running flag.

QSemaphore* syncSem

## Property Documentation

QString CalibrationFileName
| read write

QString calibrationPath
| read write

Camera calibration file path.

DisplayData displayData
| read write

Display data type.

The documentation for this class was generated from the following file:

- camera/CameraObject.h